using System;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationIEE
{
    public class IEE2018
    {

        public string INTId = null;
        public bool INTExists = false;
        public int INTCount = 0;
        public int INTOccurrenceIndex = 0;
        public int INTLastOccurrenceIndex = 0;
        public string INTIdentifier = null;
        public string INTIdentifierScheme = null;
        public string INTIdentifierABN = null;
        public DateTime? INTStartDate = null;
        public DateTime? INTEndDate = null;

        public bool DeclarationCollectionExists = false;
        public int DeclarationCollectionCount = 0;

        /// <summary>
        /// [Declaration.StatementType.Code='TrueAndCorrect']
        /// </summary>
        public bool DeclarationCollection_TrueAndCorrect_INTExists = false;

        /// <summary>
        /// [Declaration.StatementType.Code='TrueAndCorrect']
        /// </summary>
        public int DeclarationCollection_TrueAndCorrect_INTCount = 0;

        /// <summary>
        /// [Declaration.StatementType.Code='TrueAndCorrect'] Occurrence Index
        /// </summary>
        public int DeclarationCollection_TrueAndCorrect_INTOccurrenceIndex = 0;

        /// <summary>
        /// [Declaration.StatementType.Code='TrueAndCorrect'] Last Occurrence Index
        /// </summary>
        public int DeclarationCollection_TrueAndCorrect_INTLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration
        /// [Declaration.StatementType.Code='TrueAndCorrect']
        /// INT:tns:Declaration.StatementType.Code
        /// </summary>
        public string IEE159 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration
        /// [Declaration.StatementType.Code='TrueAndCorrect']
        /// INT:tns:Declaration.StatementAccepted.Indicator
        /// </summary>
        public bool? IEE179 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration
        /// [Declaration.StatementType.Code='TrueAndCorrect']
        /// INT:tns:Declaration.Statement.Text
        /// </summary>
        public string IEE180 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration
        /// [Declaration.StatementType.Code='TrueAndCorrect']
        /// INT:tns:Declaration.Signature.Date
        /// </summary>
        public DateTime? IEE181 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration
        /// [Declaration.StatementType.Code='TrueAndCorrect']
        /// INT:tns:Declaration.SignatoryIdentifier.Text
        /// </summary>
        public string IEE182 = null;

        public bool Declaration_PersonUnstructuredNameCollectionExists = false;
        public int Declaration_PersonUnstructuredNameCollectionCount = 0;

        /// <summary>
        /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory']
        /// </summary>
        public bool Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTExists = false;

        /// <summary>
        /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory']
        /// </summary>
        public int Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTCount = 0;

        /// <summary>
        /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory'] Occurrence Index
        /// </summary>
        public int Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTOccurrenceIndex = 0;

        /// <summary>
        /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory'] Last Occurrence Index
        /// </summary>
        public int Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration/tns:PersonUnstructuredName
        /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory']
        /// INT:tns:PersonUnstructuredName.Usage.Code
        /// </summary>
        public string IEE183 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration/tns:PersonUnstructuredName
        /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory']
        /// INT:tns:PersonUnstructuredName.FullName.Text
        /// </summary>
        public string IEE184 = null;

        /// <summary>
        /// INT:tns:Identifiers.TaxAgentNumber.Identifier
        /// </summary>
        public string IEE2 = null;

        public bool PersonUnstructuredNameCollectionExists = false;
        public int PersonUnstructuredNameCollectionCount = 0;

        /// <summary>
        /// [PersonUnstructuredName.Usage.Code='Contact']
        /// </summary>
        public bool PersonUnstructuredNameCollection_Contact_INTExists = false;

        /// <summary>
        /// [PersonUnstructuredName.Usage.Code='Contact']
        /// </summary>
        public int PersonUnstructuredNameCollection_Contact_INTCount = 0;

        /// <summary>
        /// [PersonUnstructuredName.Usage.Code='Contact'] Occurrence Index
        /// </summary>
        public int PersonUnstructuredNameCollection_Contact_INTOccurrenceIndex = 0;

        /// <summary>
        /// [PersonUnstructuredName.Usage.Code='Contact'] Last Occurrence Index
        /// </summary>
        public int PersonUnstructuredNameCollection_Contact_INTLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:PersonUnstructuredName
        /// [PersonUnstructuredName.Usage.Code='Contact']
        /// INT:tns:PersonUnstructuredName.Usage.Code
        /// </summary>
        public string IEE185 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:PersonUnstructuredName
        /// [PersonUnstructuredName.Usage.Code='Contact']
        /// INT:tns:PersonUnstructuredName.FullName.Text
        /// </summary>
        public string IEE186 = null;

        public bool ElectronicContactTelephoneCollectionExists = false;
        public int ElectronicContactTelephoneCollectionCount = 0;

        /// <summary>
        /// [ElectronicContact.Telephone.Usage.Code = '03']
        /// </summary>
        public bool ElectronicContactTelephoneCollection_03_INTExists = false;

        /// <summary>
        /// [ElectronicContact.Telephone.Usage.Code = '03']
        /// </summary>
        public int ElectronicContactTelephoneCollection_03_INTCount = 0;

        /// <summary>
        /// [ElectronicContact.Telephone.Usage.Code = '03'] Occurrence Index
        /// </summary>
        public int ElectronicContactTelephoneCollection_03_INTOccurrenceIndex = 0;

        /// <summary>
        /// [ElectronicContact.Telephone.Usage.Code = '03'] Last Occurrence Index
        /// </summary>
        public int ElectronicContactTelephoneCollection_03_INTLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:ElectronicContactTelephone
        /// [ElectronicContact.Telephone.Usage.Code = '03']
        /// INT:tns:ElectronicContact.Telephone.Usage.Code
        /// </summary>
        public string IEE187 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:ElectronicContactTelephone
        /// [ElectronicContact.Telephone.Usage.Code = '03']
        /// INT:tns:ElectronicContact.Telephone.ServiceLine.Code
        /// </summary>
        public string IEE188 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:ElectronicContactTelephone
        /// [ElectronicContact.Telephone.Usage.Code = '03']
        /// INT:tns:ElectronicContact.Telephone.Area.Code
        /// </summary>
        public string IEE189 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:ElectronicContactTelephone
        /// [ElectronicContact.Telephone.Usage.Code = '03']
        /// INT:tns:ElectronicContact.Telephone.Minimal.Number
        /// </summary>
        public string IEE190 = null;

        public string RPId = null;
        public bool RPExists = false;
        public int RPCount = 0;
        public int RPOccurrenceIndex = 0;
        public int RPLastOccurrenceIndex = 0;
        public string RPIdentifier = null;
        public string RPIdentifierScheme = null;
        public string RPIdentifierTFN = null;
        public DateTime? RPStartDate = null;
        public DateTime? RPEndDate = null;

        /// <summary>
        /// RP:tns:Identifiers.TaxFileNumber.Identifier
        /// </summary>
        public string IEE3 = null;

        /// <summary>
        /// RP:tns:Identifiers.AustralianBusinessNumber.Identifier
        /// </summary>
        public string IEE162 = null;

        /// <summary>
        /// RP:tns:Lodgment.PeriodYear.Year
        /// </summary>
        public int? IEE1 = null;

        /// <summary>
        /// RP:tns:OrganisationDetails.OrganisationBranch.Code
        /// </summary>
        public string IEE163 = null;

        /// <summary>
        /// RP:tns:Elections.InterposedEntityElectionOrRevocation.Code
        /// </summary>
        public string IEE116 = null;

        /// <summary>
        /// RP:tns:Report.CompletionHours.Number
        /// </summary>
        public decimal? IEE94 = null;

        /// <summary>
        /// RP:tns:Party.Type.Code
        /// </summary>
        public string IEE16 = null;

        /// <summary>
        /// RP:tns:Elections.Commencement.Date
        /// </summary>
        public DateTime? IEE49 = null;

        /// <summary>
        /// RP:tns:Elections.Revocation.Year
        /// </summary>
        public int? IEE82 = null;

        public bool OrganisationNameDetailsCollectionExists = false;
        public int OrganisationNameDetailsCollectionCount = 0;

        /// <summary>
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
        /// </summary>
        public bool OrganisationNameDetailsCollection_MN_C_RPExists = false;

        /// <summary>
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
        /// </summary>
        public int OrganisationNameDetailsCollection_MN_C_RPCount = 0;

        /// <summary>
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C'] Occurrence Index
        /// </summary>
        public int OrganisationNameDetailsCollection_MN_C_RPOccurrenceIndex = 0;

        /// <summary>
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C'] Last Occurrence Index
        /// </summary>
        public int OrganisationNameDetailsCollection_MN_C_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:OrganisationNameDetails
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
        /// RP:tns:OrganisationNameDetails.OrganisationalNameType.Code
        /// </summary>
        public string IEE117 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:OrganisationNameDetails
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
        /// RP:tns:OrganisationNameDetails.Currency.Code
        /// </summary>
        public string IEE164 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:OrganisationNameDetails
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
        /// RP:tns:OrganisationNameDetails.OrganisationalName.Text
        /// </summary>
        public string IEE4 = null;

        /// <summary>
        /// RP:tns:Identifiers.AustralianCompanyNumber.Identifier
        /// </summary>
        public string IEE100 = null;

        /// <summary>
        /// RP:tns:Identifiers.AustralianRegisteredBodyNumber.Identifier
        /// </summary>
        public string IEE101 = null;

        public bool AddressDetailsCollectionExists = false;
        public int AddressDetailsCollectionCount = 0;

        /// <summary>
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// </summary>
        public bool AddressDetailsCollection_POS_C_RPExists = false;

        /// <summary>
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// </summary>
        public int AddressDetailsCollection_POS_C_RPCount = 0;

        /// <summary>
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C'] Occurrence Index
        /// </summary>
        public int AddressDetailsCollection_POS_C_RPOccurrenceIndex = 0;

        /// <summary>
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C'] Last Occurrence Index
        /// </summary>
        public int AddressDetailsCollection_POS_C_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.OverseasAddress.Indicator
        /// </summary>
        public bool? IEE121 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Usage.Code
        /// </summary>
        public string IEE104 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Currency.Code
        /// </summary>
        public string IEE150 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Line1.Text
        /// </summary>
        public string IEE5 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Line2.Text
        /// </summary>
        public string IEE122 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Line3.Text
        /// </summary>
        public string IEE123 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Line4.Text
        /// </summary>
        public string IEE124 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.LocalityName.Text
        /// </summary>
        public string IEE6 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Postcode.Text
        /// </summary>
        public string IEE8 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.StateOrTerritory.Code
        /// </summary>
        public string IEE7 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.CountryName.Text
        /// </summary>
        public string IEE9 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Country.Code
        /// </summary>
        public string IEE111 = null;

        /// <summary>
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='P']
        /// </summary>
        public bool OrganisationNameDetailsCollection_MN_P_RPExists = false;

        /// <summary>
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='P']
        /// </summary>
        public int OrganisationNameDetailsCollection_MN_P_RPCount = 0;

        /// <summary>
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='P'] Occurrence Index
        /// </summary>
        public int OrganisationNameDetailsCollection_MN_P_RPOccurrenceIndex = 0;

        /// <summary>
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='P'] Last Occurrence Index
        /// </summary>
        public int OrganisationNameDetailsCollection_MN_P_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:OrganisationNameDetails
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='P']
        /// RP:tns:OrganisationNameDetails.OrganisationalNameType.Code
        /// </summary>
        public string IEE118 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:OrganisationNameDetails
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='P']
        /// RP:tns:OrganisationNameDetails.Currency.Code
        /// </summary>
        public string IEE165 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:OrganisationNameDetails
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='P']
        /// RP:tns:OrganisationNameDetails.OrganisationalName.Text
        /// </summary>
        public string IEE10 = null;

        /// <summary>
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// </summary>
        public bool AddressDetailsCollection_POS_P_RPExists = false;

        /// <summary>
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// </summary>
        public int AddressDetailsCollection_POS_P_RPCount = 0;

        /// <summary>
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P'] Occurrence Index
        /// </summary>
        public int AddressDetailsCollection_POS_P_RPOccurrenceIndex = 0;

        /// <summary>
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P'] Last Occurrence Index
        /// </summary>
        public int AddressDetailsCollection_POS_P_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// RP:tns:AddressDetails.OverseasAddress.Indicator
        /// </summary>
        public bool? IEE125 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// RP:tns:AddressDetails.Usage.Code
        /// </summary>
        public string IEE105 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// RP:tns:AddressDetails.Currency.Code
        /// </summary>
        public string IEE151 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// RP:tns:AddressDetails.Line1.Text
        /// </summary>
        public string IEE11 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// RP:tns:AddressDetails.Line2.Text
        /// </summary>
        public string IEE126 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// RP:tns:AddressDetails.Line3.Text
        /// </summary>
        public string IEE127 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// RP:tns:AddressDetails.Line4.Text
        /// </summary>
        public string IEE128 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// RP:tns:AddressDetails.LocalityName.Text
        /// </summary>
        public string IEE12 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// RP:tns:AddressDetails.Postcode.Text
        /// </summary>
        public string IEE14 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// RP:tns:AddressDetails.StateOrTerritory.Code
        /// </summary>
        public string IEE13 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// RP:tns:AddressDetails.CountryName.Text
        /// </summary>
        public string IEE15 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']
        /// RP:tns:AddressDetails.Country.Code
        /// </summary>
        public string IEE112 = null;

        /// <summary>
        /// RP:tns:Residency.CentralManagementAndControlOutsideAustralia.Indicator
        /// </summary>
        public bool? IEE17 = null;

        /// <summary>
        /// RP:tns:Residency.CentralManagementAndControlOutsideAustraliaFullPeriod.Indicator
        /// </summary>
        public bool? IEE18 = null;

        public bool PeriodDetailsCollectionExists = false;
        public int PeriodDetailsCollectionCount = 0;

        public List<PeriodDetailsControlOutsideAustraliaPartPeriodRP> PeriodDetailsControlOutsideAustraliaPartPeriodRPCollection = null;

        public class PeriodDetailsControlOutsideAustraliaPartPeriodRP
        {
            public int OccurrenceIndex = 0;

            /// <summary>
            /// [Period.Type.Code='ControlOutsideAustraliaPartPeriod']
            /// </summary>
            public bool PeriodDetailsCollection_ControlOutsideAustraliaPartPeriod_RPExists = false;

            /// <summary>
            /// [Period.Type.Code='ControlOutsideAustraliaPartPeriod']
            /// </summary>
            public int PeriodDetailsCollection_ControlOutsideAustraliaPartPeriod_RPCount = 0;

            /// <summary>
            /// [Period.Type.Code='ControlOutsideAustraliaPartPeriod'] Occurrence Index
            /// </summary>
            public int PeriodDetailsCollection_ControlOutsideAustraliaPartPeriod_RPOccurrenceIndex = 0;

            /// <summary>
            /// [Period.Type.Code='ControlOutsideAustraliaPartPeriod'] Last Occurrence Index
            /// </summary>
            public int PeriodDetailsCollection_ControlOutsideAustraliaPartPeriod_RPLastOccurrenceIndex = 0;

            /// <summary>
            /// /xbrli:xbrl/tns:PeriodDetails
            /// [Period.Type.Code='ControlOutsideAustraliaPartPeriod']
            /// RP:tns:Period.Type.Code
            /// </summary>
            public string IEE97 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:PeriodDetails
            /// [Period.Type.Code='ControlOutsideAustraliaPartPeriod']
            /// RP:tns:Period.Start.Date
            /// </summary>
            public DateTime? IEE19 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:PeriodDetails
            /// [Period.Type.Code='ControlOutsideAustraliaPartPeriod']
            /// RP:tns:Period.End.Date
            /// </summary>
            public DateTime? IEE20 = null;
        }

        /// <summary>
        /// RP:tns:Residency.TaxPurposesOrganisationStatus.Code
        /// </summary>
        public string IEE21 = null;

        /// <summary>
        /// RP:tns:Residency.NonResidentFullPeriod.Indicator
        /// </summary>
        public bool? IEE22 = null;

        public List<PeriodDetailsNonResidentPartPeriodRP> PeriodDetailsNonResidentPartPeriodRPCollection = null;

        public class PeriodDetailsNonResidentPartPeriodRP
        {
            public int OccurrenceIndex = 0;

            /// <summary>
            /// [Period.Type.Code='NonResidentPartPeriod']
            /// </summary>
            public bool PeriodDetailsCollection_NonResidentPartPeriod_RPExists = false;

            /// <summary>
            /// [Period.Type.Code='NonResidentPartPeriod']
            /// </summary>
            public int PeriodDetailsCollection_NonResidentPartPeriod_RPCount = 0;

            /// <summary>
            /// [Period.Type.Code='NonResidentPartPeriod'] Occurrence Index
            /// </summary>
            public int PeriodDetailsCollection_NonResidentPartPeriod_RPOccurrenceIndex = 0;

            /// <summary>
            /// [Period.Type.Code='NonResidentPartPeriod'] Last Occurrence Index
            /// </summary>
            public int PeriodDetailsCollection_NonResidentPartPeriod_RPLastOccurrenceIndex = 0;

            /// <summary>
            /// /xbrli:xbrl/tns:PeriodDetails
            /// [Period.Type.Code='NonResidentPartPeriod']
            /// RP:tns:Period.Type.Code
            /// </summary>
            public string IEE98 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:PeriodDetails
            /// [Period.Type.Code='NonResidentPartPeriod']
            /// RP:tns:Period.Start.Date
            /// </summary>
            public DateTime? IEE23 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:PeriodDetails
            /// [Period.Type.Code='NonResidentPartPeriod']
            /// RP:tns:Period.End.Date
            /// </summary>
            public DateTime? IEE24 = null;
        }

        public bool TrusteeOrPartnerCollectionExists = false;
        public int TrusteeOrPartnerCollectionCount = 0;

        public List<TrusteeOrPartner> TrusteeOrPartnerCollection = null;

        public class TrusteeOrPartner
        {
            public int OccurrenceIndex = 0;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner
            /// RP:tns:Identifiers.AustralianCompanyNumber.Identifier
            /// </summary>
            public string IEE34 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner
            /// RP:tns:Identifiers.AustralianRegisteredBodyNumber.Identifier
            /// </summary>
            public string IEE95 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner
            /// RP:tns:Identifiers.TaxFileNumber.Identifier
            /// </summary>
            public string IEE25 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner
            /// RP:tns:Identifiers.TaxFileNumberInexistent.Indicator
            /// </summary>
            public bool? IEE26 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner
            /// RP:tns:Residency.NonResidentFullPeriod.Indicator
            /// </summary>
            public bool? IEE42 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner
            /// RP:tns:Residency.TaxPurposesPersonStatus.Indicator
            /// </summary>
            public bool? IEE41 = null;

            public bool TrusteeOrPartner_OrganisationNameDetailsCollectionExists = false;
            public int TrusteeOrPartner_OrganisationNameDetailsCollectionCount = 0;

            /// <summary>
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
            /// </summary>
            public bool TrusteeOrPartner_OrganisationNameDetailsCollection_MN_C_RPExists = false;

            /// <summary>
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
            /// </summary>
            public int TrusteeOrPartner_OrganisationNameDetailsCollection_MN_C_RPCount = 0;

            /// <summary>
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C'] Occurrence Index
            /// </summary>
            public int TrusteeOrPartner_OrganisationNameDetailsCollection_MN_C_RPOccurrenceIndex = 0;

            /// <summary>
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C'] Last Occurrence Index
            /// </summary>
            public int TrusteeOrPartner_OrganisationNameDetailsCollection_MN_C_RPLastOccurrenceIndex = 0;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:OrganisationNameDetails
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
            /// RP:tns:OrganisationNameDetails.OrganisationalNameType.Code
            /// </summary>
            public string IEE167 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:OrganisationNameDetails
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
            /// RP:tns:OrganisationNameDetails.Currency.Code
            /// </summary>
            public string IEE166 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:OrganisationNameDetails
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
            /// RP:tns:OrganisationNameDetails.OrganisationalName.Text
            /// </summary>
            public string IEE32 = null;

            public bool TrusteeOrPartner_PersonNameDetailsCollectionExists = false;
            public int TrusteeOrPartner_PersonNameDetailsCollectionCount = 0;

            /// <summary>
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
            /// </summary>
            public bool TrusteeOrPartner_PersonNameDetailsCollection_LGL_Identifier_C_RPExists = false;

            /// <summary>
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
            /// </summary>
            public int TrusteeOrPartner_PersonNameDetailsCollection_LGL_Identifier_C_RPCount = 0;

            /// <summary>
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C'] Occurrence Index
            /// </summary>
            public int TrusteeOrPartner_PersonNameDetailsCollection_LGL_Identifier_C_RPOccurrenceIndex = 0;

            /// <summary>
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C'] Last Occurrence Index
            /// </summary>
            public int TrusteeOrPartner_PersonNameDetailsCollection_LGL_Identifier_C_RPLastOccurrenceIndex = 0;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.PersonNameType.Code
            /// </summary>
            public string IEE158 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.Usage.Code
            /// </summary>
            public string IEE168 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.Currency.Code
            /// </summary>
            public string IEE176 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.Title.Text
            /// </summary>
            public string IEE27 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.NameSuffix.Text
            /// </summary>
            public string IEE29 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.FamilyName.Text
            /// </summary>
            public string IEE28 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.GivenName.Text
            /// </summary>
            public string IEE30 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.OtherGivenName.Text
            /// </summary>
            public string IEE31 = null;

            public bool TrusteeOrPartner_AddressDetailsCollectionExists = false;
            public int TrusteeOrPartner_AddressDetailsCollectionCount = 0;

            /// <summary>
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// </summary>
            public bool TrusteeOrPartner_AddressDetailsCollection_POS_C_RPExists = false;

            /// <summary>
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// </summary>
            public int TrusteeOrPartner_AddressDetailsCollection_POS_C_RPCount = 0;

            /// <summary>
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C'] Occurrence Index
            /// </summary>
            public int TrusteeOrPartner_AddressDetailsCollection_POS_C_RPOccurrenceIndex = 0;

            /// <summary>
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C'] Last Occurrence Index
            /// </summary>
            public int TrusteeOrPartner_AddressDetailsCollection_POS_C_RPLastOccurrenceIndex = 0;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:AddressDetails
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// RP:tns:AddressDetails.OverseasAddress.Indicator
            /// </summary>
            public bool? IEE129 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:AddressDetails
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// RP:tns:AddressDetails.Usage.Code
            /// </summary>
            public string IEE106 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:AddressDetails
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// RP:tns:AddressDetails.Currency.Code
            /// </summary>
            public string IEE130 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:AddressDetails
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// RP:tns:AddressDetails.Line1.Text
            /// </summary>
            public string IEE35 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:AddressDetails
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// RP:tns:AddressDetails.Line2.Text
            /// </summary>
            public string IEE36 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:AddressDetails
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// RP:tns:AddressDetails.Line3.Text
            /// </summary>
            public string IEE131 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:AddressDetails
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// RP:tns:AddressDetails.Line4.Text
            /// </summary>
            public string IEE132 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:AddressDetails
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// RP:tns:AddressDetails.LocalityName.Text
            /// </summary>
            public string IEE37 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:AddressDetails
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// RP:tns:AddressDetails.Postcode.Text
            /// </summary>
            public string IEE39 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:AddressDetails
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// RP:tns:AddressDetails.StateOrTerritory.Code
            /// </summary>
            public string IEE38 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:AddressDetails
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// RP:tns:AddressDetails.CountryName.Text
            /// </summary>
            public string IEE40 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:AddressDetails
            /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
            /// RP:tns:AddressDetails.Country.Code
            /// </summary>
            public string IEE113 = null;

            public bool TrusteeOrPartner_PeriodDetailsCollectionExists = false;
            public int TrusteeOrPartner_PeriodDetailsCollectionCount = 0;

            public List<TrusteeOrPartner_PeriodDetailsNonResidentPartPeriodRP> TrusteeOrPartner_PeriodDetailsNonResidentPartPeriodRPCollection = null;

            public class TrusteeOrPartner_PeriodDetailsNonResidentPartPeriodRP
            {
                public int OccurrenceIndex = 0;

                /// <summary>
                /// [Period.Type.Code='NonResidentPartPeriod']
                /// </summary>
                public bool TrusteeOrPartner_PeriodDetailsCollection_NonResidentPartPeriod_RPExists = false;

                /// <summary>
                /// [Period.Type.Code='NonResidentPartPeriod']
                /// </summary>
                public int TrusteeOrPartner_PeriodDetailsCollection_NonResidentPartPeriod_RPCount = 0;

                /// <summary>
                /// [Period.Type.Code='NonResidentPartPeriod'] Occurrence Index
                /// </summary>
                public int TrusteeOrPartner_PeriodDetailsCollection_NonResidentPartPeriod_RPOccurrenceIndex = 0;

                /// <summary>
                /// [Period.Type.Code='NonResidentPartPeriod'] Last Occurrence Index
                /// </summary>
                public int TrusteeOrPartner_PeriodDetailsCollection_NonResidentPartPeriod_RPLastOccurrenceIndex = 0;

                /// <summary>
                /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:PeriodDetails
                /// [Period.Type.Code='NonResidentPartPeriod']
                /// RP:tns:Period.Type.Code
                /// </summary>
                public string IEE102 = null;

                /// <summary>
                /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:PeriodDetails
                /// [Period.Type.Code='NonResidentPartPeriod']
                /// RP:tns:Period.Start.Date
                /// </summary>
                public DateTime? IEE43 = null;

                /// <summary>
                /// /xbrli:xbrl/tns:TrusteeOrPartner/tns:PeriodDetails
                /// [Period.Type.Code='NonResidentPartPeriod']
                /// RP:tns:Period.End.Date
                /// </summary>
                public DateTime? IEE44 = null;
            }
        }

        /// <summary>
        /// RP:tns:Elections.InterposedEntityElectionStatus.Year
        /// </summary>
        public int? IEE45 = null;

        /// <summary>
        /// RP:tns:Elections.DateSpecified.Date
        /// </summary>
        public DateTime? IEE46 = null;

        /// <summary>
        /// [Period.Type.Code='SubstitutedAccountingPeriod']
        /// </summary>
        public bool PeriodDetailsCollection_SubstitutedAccountingPeriod_RPExists = false;

        /// <summary>
        /// [Period.Type.Code='SubstitutedAccountingPeriod']
        /// </summary>
        public int PeriodDetailsCollection_SubstitutedAccountingPeriod_RPCount = 0;

        /// <summary>
        /// [Period.Type.Code='SubstitutedAccountingPeriod'] Occurrence Index
        /// </summary>
        public int PeriodDetailsCollection_SubstitutedAccountingPeriod_RPOccurrenceIndex = 0;

        /// <summary>
        /// [Period.Type.Code='SubstitutedAccountingPeriod'] Last Occurrence Index
        /// </summary>
        public int PeriodDetailsCollection_SubstitutedAccountingPeriod_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:PeriodDetails
        /// [Period.Type.Code='SubstitutedAccountingPeriod']
        /// RP:tns:Period.Type.Code
        /// </summary>
        public string IEE99 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:PeriodDetails
        /// [Period.Type.Code='SubstitutedAccountingPeriod']
        /// RP:tns:Period.Start.Date
        /// </summary>
        public DateTime? IEE47 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:PeriodDetails
        /// [Period.Type.Code='SubstitutedAccountingPeriod']
        /// RP:tns:Period.End.Date
        /// </summary>
        public DateTime? IEE48 = null;

        public bool FamilyTrustCollectionExists = false;
        public int FamilyTrustCollectionCount = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust
        /// RP:tns:Elections.Commencement.Date
        /// </summary>
        public DateTime? IEE59 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust
        /// RP:tns:Elections.FamilyTrustElectionStatus.Year
        /// </summary>
        public int? IEE58 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust
        /// RP:tns:Identifiers.TaxFileNumber.Identifier
        /// </summary>
        public string IEE50 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust
        /// RP:tns:Identifiers.TaxFileNumberInexistent.Indicator
        /// </summary>
        public bool? IEE51 = null;

        public bool FamilyTrust_OrganisationNameDetailsCollectionExists = false;
        public int FamilyTrust_OrganisationNameDetailsCollectionCount = 0;

        /// <summary>
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
        /// </summary>
        public bool FamilyTrust_OrganisationNameDetailsCollection_MN_C_RPExists = false;

        /// <summary>
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
        /// </summary>
        public int FamilyTrust_OrganisationNameDetailsCollection_MN_C_RPCount = 0;

        /// <summary>
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C'] Occurrence Index
        /// </summary>
        public int FamilyTrust_OrganisationNameDetailsCollection_MN_C_RPOccurrenceIndex = 0;

        /// <summary>
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C'] Last Occurrence Index
        /// </summary>
        public int FamilyTrust_OrganisationNameDetailsCollection_MN_C_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:OrganisationNameDetails
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
        /// RP:tns:OrganisationNameDetails.OrganisationalNameType.Code
        /// </summary>
        public string IEE119 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:OrganisationNameDetails
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
        /// RP:tns:OrganisationNameDetails.Currency.Code
        /// </summary>
        public string IEE170 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:OrganisationNameDetails
        /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
        /// RP:tns:OrganisationNameDetails.OrganisationalName.Text
        /// </summary>
        public string IEE52 = null;

        public bool FamilyTrust_AddressDetailsCollectionExists = false;
        public int FamilyTrust_AddressDetailsCollectionCount = 0;

        /// <summary>
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// </summary>
        public bool FamilyTrust_AddressDetailsCollection_POS_C_RPExists = false;

        /// <summary>
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// </summary>
        public int FamilyTrust_AddressDetailsCollection_POS_C_RPCount = 0;

        /// <summary>
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C'] Occurrence Index
        /// </summary>
        public int FamilyTrust_AddressDetailsCollection_POS_C_RPOccurrenceIndex = 0;

        /// <summary>
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C'] Last Occurrence Index
        /// </summary>
        public int FamilyTrust_AddressDetailsCollection_POS_C_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.OverseasAddress.Indicator
        /// </summary>
        public bool? IEE133 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Usage.Code
        /// </summary>
        public string IEE107 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Currency.Code
        /// </summary>
        public string IEE153 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Line1.Text
        /// </summary>
        public string IEE53 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Line2.Text
        /// </summary>
        public string IEE134 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Line3.Text
        /// </summary>
        public string IEE135 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Line4.Text
        /// </summary>
        public string IEE136 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.LocalityName.Text
        /// </summary>
        public string IEE54 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Postcode.Text
        /// </summary>
        public string IEE56 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.StateOrTerritory.Code
        /// </summary>
        public string IEE55 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.CountryName.Text
        /// </summary>
        public string IEE57 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:AddressDetails
        /// [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Country.Code
        /// </summary>
        public string IEE155 = null;

        public bool FamilyTrust_PeriodDetailsCollectionExists = false;
        public int FamilyTrust_PeriodDetailsCollectionCount = 0;

        /// <summary>
        /// [Period.Type.Code='SubstitutedAccountingPeriod']
        /// </summary>
        public bool FamilyTrust_PeriodDetailsCollection_SubstitutedAccountingPeriod_RPExists = false;

        /// <summary>
        /// [Period.Type.Code='SubstitutedAccountingPeriod']
        /// </summary>
        public int FamilyTrust_PeriodDetailsCollection_SubstitutedAccountingPeriod_RPCount = 0;

        /// <summary>
        /// [Period.Type.Code='SubstitutedAccountingPeriod'] Occurrence Index
        /// </summary>
        public int FamilyTrust_PeriodDetailsCollection_SubstitutedAccountingPeriod_RPOccurrenceIndex = 0;

        /// <summary>
        /// [Period.Type.Code='SubstitutedAccountingPeriod'] Last Occurrence Index
        /// </summary>
        public int FamilyTrust_PeriodDetailsCollection_SubstitutedAccountingPeriod_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:PeriodDetails
        /// [Period.Type.Code='SubstitutedAccountingPeriod']
        /// RP:tns:Period.Type.Code
        /// </summary>
        public string IEE103 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:PeriodDetails
        /// [Period.Type.Code='SubstitutedAccountingPeriod']
        /// RP:tns:Period.Start.Date
        /// </summary>
        public DateTime? IEE60 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:FamilyTrust/tns:PeriodDetails
        /// [Period.Type.Code='SubstitutedAccountingPeriod']
        /// RP:tns:Period.End.Date
        /// </summary>
        public DateTime? IEE61 = null;

        public bool SpecifiedIndividualCollectionExists = false;
        public int SpecifiedIndividualCollectionCount = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual
        /// RP:tns:Identifiers.TaxFileNumber.Identifier
        /// </summary>
        public string IEE62 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual
        /// RP:tns:Identifiers.TaxFileNumberInexistent.Indicator
        /// </summary>
        public bool? IEE63 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual
        /// RP:tns:PersonDemographicDetails.Birth.Date
        /// </summary>
        public DateTime? IEE64 = null;

        public bool SpecifiedIndividual_PersonNameDetailsCollectionExists = false;
        public int SpecifiedIndividual_PersonNameDetailsCollectionCount = 0;

        /// <summary>
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
        /// </summary>
        public bool SpecifiedIndividual_PersonNameDetailsCollection_LGL_Identifier_C_RPExists = false;

        /// <summary>
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
        /// </summary>
        public int SpecifiedIndividual_PersonNameDetailsCollection_LGL_Identifier_C_RPCount = 0;

        /// <summary>
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C'] Occurrence Index
        /// </summary>
        public int SpecifiedIndividual_PersonNameDetailsCollection_LGL_Identifier_C_RPOccurrenceIndex = 0;

        /// <summary>
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C'] Last Occurrence Index
        /// </summary>
        public int SpecifiedIndividual_PersonNameDetailsCollection_LGL_Identifier_C_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.PersonNameType.Code
        /// </summary>
        public string IEE171 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.Usage.Code
        /// </summary>
        public string IEE172 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.Currency.Code
        /// </summary>
        public string IEE177 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.Title.Text
        /// </summary>
        public string IEE65 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.NameSuffix.Text
        /// </summary>
        public string IEE67 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.FamilyName.Text
        /// </summary>
        public string IEE66 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.GivenName.Text
        /// </summary>
        public string IEE68 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Identifier'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.OtherGivenName.Text
        /// </summary>
        public string IEE69 = null;

        public bool SpecifiedIndividual_AddressDetailsCollectionExists = false;
        public int SpecifiedIndividual_AddressDetailsCollectionCount = 0;

        /// <summary>
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// </summary>
        public bool SpecifiedIndividual_AddressDetailsCollection_RES_C_RPExists = false;

        /// <summary>
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// </summary>
        public int SpecifiedIndividual_AddressDetailsCollection_RES_C_RPCount = 0;

        /// <summary>
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C'] Occurrence Index
        /// </summary>
        public int SpecifiedIndividual_AddressDetailsCollection_RES_C_RPOccurrenceIndex = 0;

        /// <summary>
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C'] Last Occurrence Index
        /// </summary>
        public int SpecifiedIndividual_AddressDetailsCollection_RES_C_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:AddressDetails
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.OverseasAddress.Indicator
        /// </summary>
        public bool? IEE137 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:AddressDetails
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Usage.Code
        /// </summary>
        public string IEE108 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:AddressDetails
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Currency.Code
        /// </summary>
        public string IEE152 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:AddressDetails
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Line1.Text
        /// </summary>
        public string IEE70 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:AddressDetails
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Line2.Text
        /// </summary>
        public string IEE138 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:AddressDetails
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Line3.Text
        /// </summary>
        public string IEE139 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:AddressDetails
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Line4.Text
        /// </summary>
        public string IEE140 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:AddressDetails
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.LocalityName.Text
        /// </summary>
        public string IEE71 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:AddressDetails
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Postcode.Text
        /// </summary>
        public string IEE73 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:AddressDetails
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.StateOrTerritory.Code
        /// </summary>
        public string IEE72 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:AddressDetails
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.CountryName.Text
        /// </summary>
        public string IEE74 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:SpecifiedIndividual/tns:AddressDetails
        /// [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
        /// RP:tns:AddressDetails.Country.Code
        /// </summary>
        public string IEE114 = null;

        public bool DeclarationOfTrusteeOrPartnerCollectionExists = false;
        public int DeclarationOfTrusteeOrPartnerCollectionCount = 0;

        public List<DeclarationOfTrusteeOrPartner> DeclarationOfTrusteeOrPartnerCollection = null;

        public class DeclarationOfTrusteeOrPartner
        {
            public int OccurrenceIndex = 0;

            public bool DeclarationOfTrusteeOrPartner_PersonNameDetailsCollectionExists = false;
            public int DeclarationOfTrusteeOrPartner_PersonNameDetailsCollectionCount = 0;

            /// <summary>
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
            /// </summary>
            public bool DeclarationOfTrusteeOrPartner_PersonNameDetailsCollection_LGL_DeclarationSignatory_C_RPExists = false;

            /// <summary>
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
            /// </summary>
            public int DeclarationOfTrusteeOrPartner_PersonNameDetailsCollection_LGL_DeclarationSignatory_C_RPCount = 0;

            /// <summary>
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C'] Occurrence Index
            /// </summary>
            public int DeclarationOfTrusteeOrPartner_PersonNameDetailsCollection_LGL_DeclarationSignatory_C_RPOccurrenceIndex = 0;

            /// <summary>
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C'] Last Occurrence Index
            /// </summary>
            public int DeclarationOfTrusteeOrPartner_PersonNameDetailsCollection_LGL_DeclarationSignatory_C_RPLastOccurrenceIndex = 0;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.PersonNameType.Code
            /// </summary>
            public string IEE198 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.Usage.Code
            /// </summary>
            public string IEE199 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.Currency.Code
            /// </summary>
            public string IEE200 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.Title.Text
            /// </summary>
            public string IEE201 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.NameSuffix.Text
            /// </summary>
            public string IEE202 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.FamilyName.Text
            /// </summary>
            public string IEE203 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.GivenName.Text
            /// </summary>
            public string IEE204 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:PersonNameDetails
            /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
            /// RP:tns:PersonNameDetails.OtherGivenName.Text
            /// </summary>
            public string IEE205 = null;

            public bool DeclarationOfTrusteeOrPartner_OrganisationNameDetailsCollectionExists = false;
            public int DeclarationOfTrusteeOrPartner_OrganisationNameDetailsCollectionCount = 0;

            /// <summary>
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
            /// </summary>
            public bool DeclarationOfTrusteeOrPartner_OrganisationNameDetailsCollection_MN_C_RPExists = false;

            /// <summary>
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
            /// </summary>
            public int DeclarationOfTrusteeOrPartner_OrganisationNameDetailsCollection_MN_C_RPCount = 0;

            /// <summary>
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C'] Occurrence Index
            /// </summary>
            public int DeclarationOfTrusteeOrPartner_OrganisationNameDetailsCollection_MN_C_RPOccurrenceIndex = 0;

            /// <summary>
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C'] Last Occurrence Index
            /// </summary>
            public int DeclarationOfTrusteeOrPartner_OrganisationNameDetailsCollection_MN_C_RPLastOccurrenceIndex = 0;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:OrganisationNameDetails
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
            /// RP:tns:OrganisationNameDetails.OrganisationalNameType.Code
            /// </summary>
            public string IEE173 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:OrganisationNameDetails
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
            /// RP:tns:OrganisationNameDetails.Currency.Code
            /// </summary>
            public string IEE178 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:OrganisationNameDetails
            /// [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']
            /// RP:tns:OrganisationNameDetails.OrganisationalName.Text
            /// </summary>
            public string IEE88 = null;

            public bool DeclarationOfTrusteeOrPartner_DeclarationCollectionExists = false;
            public int DeclarationOfTrusteeOrPartner_DeclarationCollectionCount = 0;

            public bool RpDeclarationOfTrusteeOrPartner_DeclarationCollectionExists = false;
            public int RpDeclarationOfTrusteeOrPartner_DeclarationCollectionCount = 0;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:Declaration
            /// RP:tns:Declaration.StatementType.Code
            /// </summary>
            public string IEE193 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:Declaration
            /// RP:tns:Declaration.StatementAccepted.Indicator
            /// </summary>
            public bool? IEE146 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:Declaration
            /// RP:tns:Declaration.Statement.Text
            /// </summary>
            public string IEE194 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:Declaration
            /// RP:tns:Declaration.Signature.Date
            /// </summary>
            public DateTime? IEE90 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:Declaration
            /// RP:tns:Declaration.SignatoryIdentifier.Text
            /// </summary>
            public string IEE195 = null;

            public bool DeclarationOfTrusteeOrPartner_Declaration_PersonUnstructuredNameCollectionExists = false;
            public int DeclarationOfTrusteeOrPartner_Declaration_PersonUnstructuredNameCollectionCount = 0;

            /// <summary>
            /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory']
            /// </summary>
            public bool DeclarationOfTrusteeOrPartner_Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPExists = false;

            /// <summary>
            /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory']
            /// </summary>
            public int DeclarationOfTrusteeOrPartner_Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPCount = 0;

            /// <summary>
            /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory'] Occurrence Index
            /// </summary>
            public int DeclarationOfTrusteeOrPartner_Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPOccurrenceIndex = 0;

            /// <summary>
            /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory'] Last Occurrence Index
            /// </summary>
            public int DeclarationOfTrusteeOrPartner_Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPLastOccurrenceIndex = 0;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:Declaration/tns:PersonUnstructuredName
            /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory']
            /// RP:tns:PersonUnstructuredName.Usage.Code
            /// </summary>
            public string IEE196 = null;

            /// <summary>
            /// /xbrli:xbrl/tns:DeclarationOfTrusteeOrPartner/tns:Declaration/tns:PersonUnstructuredName
            /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory']
            /// RP:tns:PersonUnstructuredName.FullName.Text
            /// </summary>
            public string IEE197 = null;
        }

        public bool PersonNameDetailsCollectionExists = false;
        public int PersonNameDetailsCollectionCount = 0;

        /// <summary>
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
        /// </summary>
        public bool PersonNameDetailsCollection_LGL_DeclarationSignatory_C_RPExists = false;

        /// <summary>
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
        /// </summary>
        public int PersonNameDetailsCollection_LGL_DeclarationSignatory_C_RPCount = 0;

        /// <summary>
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C'] Occurrence Index
        /// </summary>
        public int PersonNameDetailsCollection_LGL_DeclarationSignatory_C_RPOccurrenceIndex = 0;

        /// <summary>
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C'] Last Occurrence Index
        /// </summary>
        public int PersonNameDetailsCollection_LGL_DeclarationSignatory_C_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.PersonNameType.Code
        /// </summary>
        public string IEE174 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.Usage.Code
        /// </summary>
        public string IEE157 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.Currency.Code
        /// </summary>
        public string IEE175 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.Title.Text
        /// </summary>
        public string IEE83 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.NameSuffix.Text
        /// </summary>
        public string IEE85 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.FamilyName.Text
        /// </summary>
        public string IEE84 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.GivenName.Text
        /// </summary>
        public string IEE86 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:PersonNameDetails
        /// [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='DeclarationSignatory'].[PersonNameDetails.Currency.Code='C']
        /// RP:tns:PersonNameDetails.OtherGivenName.Text
        /// </summary>
        public string IEE87 = null;

        /// <summary>
        /// [Declaration.StatementType.Code = 'TrueAndCorrect']
        /// </summary>
        public bool DeclarationCollection_TrueAndCorrect_RPExists = false;

        /// <summary>
        /// [Declaration.StatementType.Code = 'TrueAndCorrect']
        /// </summary>
        public int DeclarationCollection_TrueAndCorrect_RPCount = 0;

        /// <summary>
        /// [Declaration.StatementType.Code = 'TrueAndCorrect'] Occurrence Index
        /// </summary>
        public int DeclarationCollection_TrueAndCorrect_RPOccurrenceIndex = 0;

        /// <summary>
        /// [Declaration.StatementType.Code = 'TrueAndCorrect'] Last Occurrence Index
        /// </summary>
        public int DeclarationCollection_TrueAndCorrect_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration
        /// [Declaration.StatementType.Code = 'TrueAndCorrect']
        /// RP:tns:Declaration.StatementType.Code
        /// </summary>
        public string IEE147 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration
        /// [Declaration.StatementType.Code = 'TrueAndCorrect']
        /// RP:tns:Declaration.StatementAccepted.Indicator
        /// </summary>
        public bool? IEE192 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration
        /// [Declaration.StatementType.Code = 'TrueAndCorrect']
        /// RP:tns:Declaration.Statement.Text
        /// </summary>
        public string IEE149 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration
        /// [Declaration.StatementType.Code = 'TrueAndCorrect']
        /// RP:tns:Declaration.Signature.Date
        /// </summary>
        public DateTime? IEE191 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration
        /// [Declaration.StatementType.Code = 'TrueAndCorrect']
        /// RP:tns:Declaration.SignatoryIdentifier.Text
        /// </summary>
        public string IEE148 = null;

        /// <summary>
        /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory']
        /// </summary>
        public bool Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPExists = false;

        /// <summary>
        /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory']
        /// </summary>
        public int Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPCount = 0;

        /// <summary>
        /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory'] Occurrence Index
        /// </summary>
        public int Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPOccurrenceIndex = 0;

        /// <summary>
        /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory'] Last Occurrence Index
        /// </summary>
        public int Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPLastOccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration/tns:PersonUnstructuredName
        /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory']
        /// RP:tns:PersonUnstructuredName.Usage.Code
        /// </summary>
        public string IEE156 = null;

        /// <summary>
        /// /xbrli:xbrl/tns:Declaration/tns:PersonUnstructuredName
        /// [PersonUnstructuredName.Usage.Code='DeclarationSignatory']
        /// RP:tns:PersonUnstructuredName.FullName.Text
        /// </summary>
        public string IEE91 = null;

    }
}