﻿using System.Collections.Generic;
using Ato.EN.IntegrationServices.CodeGenerationIDS;

namespace Ato.CD.Inbound.Shared
{
    public static class IDS2018ContextsExtension
    {
        public static List<Context> GetContexts(this IDS2018 ids)
        {
            var contexts = new List<Context>();

            contexts.AddContext(ids.RPStartDate, ids.RPEndDate, ids.RPOccurrenceIndex).
                AddContext(ids.RPQuarterlyStartDate, ids.RPQuarterlyEndDate, ids.RPQuarterlyOccurrenceIndex).
                AddContext(ids.RPAssetManagementStartDate, ids.RPAssetManagementEndDate, ids.RPAssetManagementOccurrenceIndex).
                AddContext(ids.RPBranchOperationsStartDate, ids.RPBranchOperationsEndDate, ids.RPBranchOperationsOccurrenceIndex).
                AddContext(ids.RPCapitalNonMonetaryPaymentStartDate, ids.RPCapitalNonMonetaryPaymentEndDate, ids.RPCapitalNonMonetaryPaymentOccurrenceIndex).
                AddContext(ids.RPCapitalNoPaymentStartDate, ids.RPCapitalNoPaymentEndDate, ids.RPCapitalNoPaymentOccurrenceIndex).
                AddContext(ids.RPDebtFactoringStartDate, ids.RPDebtFactoringEndDate, ids.RPDebtFactoringOccurrenceIndex).
                AddContext(ids.RPDerivativesStartDate, ids.RPDerivativesEndDate, ids.RPDerivativesOccurrenceIndex).
                AddContext(ids.RPInsuranceStartDate, ids.RPInsuranceEndDate, ids.RPInsuranceOccurrenceIndex).
                AddContext(ids.RPLicenceFeesStartDate, ids.RPLicenceFeesEndDate, ids.RPLicenceFeesOccurrenceIndex).
                AddContext(ids.RPLogisticsStartDate, ids.RPLogisticsEndDate, ids.RPLogisticsOccurrenceIndex).
                AddContext(ids.RPManagementAndAdminStartDate, ids.RPManagementAndAdminEndDate, ids.RPManagementAndAdminOccurrenceIndex).
                AddContext(ids.RPOtherFinancialDealingsStartDate, ids.RPOtherFinancialDealingsEndDate, ids.RPOtherFinancialDealingsOccurrenceIndex).
                AddContext(ids.RPOtherGuaranteesStartDate, ids.RPOtherGuaranteesEndDate, ids.RPOtherGuaranteesOccurrenceIndex).
                AddContext(ids.RPOtherInsuranceStartDate, ids.RPOtherInsuranceEndDate, ids.RPOtherInsuranceOccurrenceIndex).
                AddContext(ids.RPOtherInterestStartDate, ids.RPOtherInterestEndDate, ids.RPOtherInterestOccurrenceIndex).
                AddContext(ids.RPOtherNotReportedIntangibleNonRevenueStartDate, ids.RPOtherNotReportedIntangibleNonRevenueEndDate, ids.RPOtherNotReportedIntangibleNonRevenueOccurrenceIndex).
                AddContext(ids.RPOtherNotReportedRevenueStartDate, ids.RPOtherNotReportedRevenueEndDate, ids.RPOtherNotReportedRevenueOccurrenceIndex).
                AddContext(ids.RPOtherNotReportedTangibleNonRevenueStartDate, ids.RPOtherNotReportedTangibleNonRevenueEndDate, ids.RPOtherNotReportedTangibleNonRevenueOccurrenceIndex).
                AddContext(ids.RPOtherReinsuranceStartDate, ids.RPOtherReinsuranceEndDate, ids.RPOtherReinsuranceOccurrenceIndex).
                AddContext(ids.RPOtherServicesStartDate, ids.RPOtherServicesEndDate, ids.RPOtherServicesOccurrenceIndex).
                AddContext(ids.RPRechargeAmountsStartDate, ids.RPRechargeAmountsEndDate, ids.RPRechargeAmountsOccurrenceIndex).
                AddContext(ids.RPReinsuranceStartDate, ids.RPReinsuranceEndDate, ids.RPReinsuranceOccurrenceIndex).
                AddContext(ids.RPRentLeaseStartDate, ids.RPRentLeaseEndDate, ids.RPRentLeaseOccurrenceIndex).
                AddContext(ids.RPResearchAndDevelopmentStartDate, ids.RPResearchAndDevelopmentEndDate, ids.RPResearchAndDevelopmentOccurrenceIndex).
                AddContext(ids.RPRevenueNonMonetaryPaymentStartDate, ids.RPRevenueNonMonetaryPaymentEndDate, ids.RPRevenueNonMonetaryPaymentOccurrenceIndex).
                AddContext(ids.RPRevenueNoPaymentStartDate, ids.RPRevenueNoPaymentEndDate, ids.RPRevenueNoPaymentOccurrenceIndex).
                AddContext(ids.RPRoyaltiesStartDate, ids.RPRoyaltiesEndDate, ids.RPRoyaltiesOccurrenceIndex).
                AddContext(ids.RPSalesAndMarketingStartDate, ids.RPSalesAndMarketingEndDate, ids.RPSalesAndMarketingOccurrenceIndex).
                AddContext(ids.RPSecuritisationStartDate, ids.RPSecuritisationEndDate, ids.RPSecuritisationOccurrenceIndex).
                AddContext(ids.RPSoftwareAndITServicesStartDate, ids.RPSoftwareAndITServicesEndDate, ids.RPSoftwareAndITServicesOccurrenceIndex).
                AddContext(ids.RPTangibleRevenueStartDate, ids.RPTangibleRevenueEndDate, ids.RPTangibleRevenueOccurrenceIndex).
                AddContext(ids.RPTechnicalStartDate, ids.RPTechnicalEndDate, ids.RPTechnicalOccurrenceIndex).
                AddContext(ids.RPTreasuryRelatedStartDate, ids.RPTreasuryRelatedEndDate, ids.RPTreasuryRelatedOccurrenceIndex).
                AddContext(ids.RPOtherNotReportedAssignmentOfIntangibleNonRevenueStartDate, ids.RPOtherNotReportedAssignmentOfIntangibleNonRevenueEndDate, ids.RPOtherNotReportedAssignmentOfIntangibleNonRevenueOccurrenceIndex).
                AddContext(ids.RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueStartDate, ids.RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueEndDate, ids.RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueOccurrenceIndex).
                AddContext(ids.RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueStartDate, ids.RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueEndDate, ids.RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueOccurrenceIndex).
                AddContext(ids.RPOverseasIntangiblesStartDate, ids.RPOverseasIntangiblesEndDate, ids.RPOverseasIntangiblesOccurrenceIndex).
                AddContext(ids.RPAdvisoryStartDate, ids.RPAdvisoryEndDate, ids.RPAdvisoryOccurrenceIndex).
                AddContext(ids.RPBorrowingStartDate, ids.RPBorrowingEndDate, ids.RPBorrowingOccurrenceIndex).
                AddContext(ids.RPDivision770StartDate, ids.RPDivision770EndDate, ids.RPDivision770OccurrenceIndex).
                AddContext(ids.RPEligibleContractStartDate, ids.RPEligibleContractEndDate, ids.RPEligibleContractOccurrenceIndex).
                AddContext(ids.RPGuaranteeTypeStartDate, ids.RPGuaranteeTypeEndDate, ids.RPGuaranteeTypeOccurrenceIndex).
                AddContext(ids.RPGeneralDeductionStartDate, ids.RPGeneralDeductionEndDate, ids.RPGeneralDeductionOccurrenceIndex).
                AddContext(ids.RPHedgingStartDate, ids.RPHedgingEndDate, ids.RPHedgingOccurrenceIndex).
                AddContext(ids.RPInvestmentStartDate, ids.RPInvestmentEndDate, ids.RPInvestmentOccurrenceIndex).
                AddContext(ids.RPLendingStartDate, ids.RPLendingEndDate, ids.RPLendingOccurrenceIndex).
                AddContext(ids.RPOtherStartDate, ids.RPOtherEndDate, ids.RPOtherOccurrenceIndex).
                AddContext(ids.RPTotalNetStartDate, ids.RPTotalNetEndDate, ids.RPTotalNetOccurrenceIndex).
                AddContext(ids.RPTradingStartDate, ids.RPTradingEndDate, ids.RPTradingOccurrenceIndex).
                AddContext(ids.RPLeasingStartDate, ids.RPLeasingEndDate, ids.RPLeasingOccurrenceIndex).
                AddContext(ids.RPCFCLCStartDate, ids.RPCFCLCEndDate, ids.RPCFCLCOccurrenceIndex).
                AddContext(ids.RPCFCSPStartDate, ids.RPCFCSPEndDate, ids.RPCFCSPOccurrenceIndex).
                AddContext(ids.RPCFCUCStartDate, ids.RPCFCUCEndDate, ids.RPCFCUCOccurrenceIndex).
                AddContext(ids.RPDTAStartDate, ids.RPDTAEndDate, ids.RPDTAOccurrenceIndex).
                AddContext(ids.RPs128FStartDate, ids.RPs128FEndDate, ids.RPs128FOccurrenceIndex).
                AddContext(ids.RPs128FAStartDate, ids.RPs128FAEndDate, ids.RPs128FAOccurrenceIndex).
                AddContext(ids.RPAdvisoryRelatedPartyStartDate, ids.RPAdvisoryRelatedPartyEndDate, ids.RPAdvisoryRelatedPartyOccurrenceIndex).
                AddContext(ids.RPBorrowingRelatedPartyStartDate, ids.RPBorrowingRelatedPartyEndDate, ids.RPBorrowingRelatedPartyOccurrenceIndex).
                AddContext(ids.RPEligibleContractRelatedPartyStartDate, ids.RPEligibleContractRelatedPartyEndDate, ids.RPEligibleContractRelatedPartyOccurrenceIndex).
                AddContext(ids.RPGuaranteeTypeRelatedPartyStartDate, ids.RPGuaranteeTypeRelatedPartyEndDate, ids.RPGuaranteeTypeRelatedPartyOccurrenceIndex).
                AddContext(ids.RPHedgingRelatedPartyStartDate, ids.RPHedgingRelatedPartyEndDate, ids.RPHedgingRelatedPartyOccurrenceIndex).
                AddContext(ids.RPInvestmentRelatedPartyStartDate, ids.RPInvestmentRelatedPartyEndDate, ids.RPInvestmentRelatedPartyOccurrenceIndex).
                AddContext(ids.RPLendingRelatedPartyStartDate, ids.RPLendingRelatedPartyEndDate, ids.RPLendingRelatedPartyOccurrenceIndex).
                AddContext(ids.RPOtherRelatedPartyStartDate, ids.RPOtherRelatedPartyEndDate, ids.RPOtherRelatedPartyOccurrenceIndex).
                AddContext(ids.RPTotalNetRelatedPartyStartDate, ids.RPTotalNetRelatedPartyEndDate, ids.RPTotalNetRelatedPartyOccurrenceIndex).
                AddContext(ids.RPTradingRelatedPartyStartDate, ids.RPTradingRelatedPartyEndDate, ids.RPTradingRelatedPartyOccurrenceIndex).
                AddContext(ids.RPLeasingRelatedPartyStartDate, ids.RPLeasingRelatedPartyEndDate, ids.RPLeasingRelatedPartyOccurrenceIndex).
                AddContext(ids.RPBranchOperationsInterestFreeStartDate, ids.RPBranchOperationsInterestFreeEndDate, ids.RPBranchOperationsInterestFreeOccurrenceIndex).
                AddContext(ids.RPBranchOperationsInterestBearingStartDate, ids.RPBranchOperationsInterestBearingEndDate, ids.RPBranchOperationsInterestBearingOccurrenceIndex).
                AddContext(ids.RPOtherFinancialDealingsInterestFreeStartDate, ids.RPOtherFinancialDealingsInterestFreeEndDate, ids.RPOtherFinancialDealingsInterestFreeOccurrenceIndex).
                AddContext(ids.RPOtherFinancialDealingsInterestBearingStartDate, ids.RPOtherFinancialDealingsInterestBearingEndDate, ids.RPOtherFinancialDealingsInterestBearingOccurrenceIndex).
                AddContext(ids.RPCrossBorderHybridStartDate, ids.RPCrossBorderHybridEndDate, ids.RPCrossBorderHybridOccurrenceIndex).
                AddContext(ids.RPForeignHubsStartDate, ids.RPForeignHubsEndDate, ids.RPForeignHubsOccurrenceIndex).
                AddContext(ids.RPHybridInstrumentsStartDate, ids.RPHybridInstrumentsEndDate, ids.RPHybridInstrumentsOccurrenceIndex);

            if (ids.RPTrustExemptionCodeContextCollection != null)
            {
                foreach (var ChildTrustExemptionCodeContext in ids.RPTrustExemptionCodeContextCollection)
                {
                    contexts.AddContext(ChildTrustExemptionCodeContext.StartDate, ChildTrustExemptionCodeContext.EndDate, ChildTrustExemptionCodeContext.OccurrenceIndex);

                }
            }
            if (ids.RPRestructuringEventContextCollection != null)
            {
                foreach (var RPRestructuringEventContext in ids.RPRestructuringEventContextCollection)
                {

                    contexts.AddContext(RPRestructuringEventContext.StartDate, RPRestructuringEventContext.EndDate, RPRestructuringEventContext.OccurrenceIndex);
                }
            }

            if (ids.RPBranchOperationsInternallyRecordedDealingsContextCollection != null)
            {
                foreach (var RPBranchOperationsInternallyRecordedDealingsContext in ids.RPBranchOperationsInternallyRecordedDealingsContextCollection)
                {
                    contexts.AddContext(RPBranchOperationsInternallyRecordedDealingsContext.StartDate, RPBranchOperationsInternallyRecordedDealingsContext.EndDate, RPBranchOperationsInternallyRecordedDealingsContext.OccurrenceIndex);
                }
            }

            return contexts;
        }
    }
}