using System;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationTRTAMI
{
    public class TRTAMI2018
    {

        public string RPId = null;
        public bool RPExists = false;
        public int RPCount = 0;
        public int RPOccurrenceIndex = 0;
        public int RPLastOccurrenceIndex = 0;
        public string RPIdentifier = null;
        public string RPIdentifierScheme = null;
        public string RPIdentifierTFN = null;
        public DateTime? RPStartDate = null;
        public DateTime? RPEndDate = null;

        /// <summary>
        /// RP:tns:ContextPeriodStartDate
        /// </summary>
        public DateTime? TRTAMI2 = null;

        /// <summary>
        /// RP:tns:ContextPeriodEndDate
        /// </summary>
        public DateTime? TRTAMI3 = null;

        /// <summary>
        /// RP:tns:Identifiers.TaxFileNumber.Identifier
        /// </summary>
        public string TRTAMI4 = null;

        /// <summary>
        /// RP:tns:Report.TargetFinancial.Year
        /// </summary>
        public int? TRTAMI1 = null;

        /// <summary>
        /// RP:tns:Identifiers.AustralianBusinessNumber.Identifier
        /// </summary>
        public string TRTAMI5 = null;

        /// <summary>
        /// RP:tns:Report.Amendment.Indicator
        /// </summary>
        public bool? TRTAMI6 = null;

        /// <summary>
        /// RP:tns:Report.AmendmentType.Code
        /// </summary>
        public string TRTAMI7 = null;

        /// <summary>
        /// RP:tns:Report.AmendmentReason.Text
        /// </summary>
        public string TRTAMI8 = null;

        /// <summary>
        /// RP:tns:Report.AmendmentSequence.Number
        /// </summary>
        public decimal? TRTAMI9 = null;

        /// <summary>
        /// RP:tns:OrganisationNameDetails.OrganisationalName.Text
        /// </summary>
        public string TRTAMI10 = null;

        /// <summary>
        /// RP:tns:IncomeTax.TrustComponentDeficitOffset.Amount
        /// </summary>
        public decimal? TRTAMI35 = null;

        /// <summary>
        /// RP:tns:IncomeTax.TrustShortfallIncome.Amount
        /// </summary>
        public decimal? TRTAMI36 = null;

        /// <summary>
        /// RP:tns:IncomeTax.TrustExcessOffset.Amount
        /// </summary>
        public decimal? TRTAMI39 = null;

        /// <summary>
        /// RP:tns:IncomeTax.TrustComponentNotReflected.Amount
        /// </summary>
        public decimal? TRTAMI40 = null;

        /// <summary>
        /// RP:tns:FinancialInstitutionAccount.BankStateBranch.Number
        /// </summary>
        public string TRTAMI41 = null;

        /// <summary>
        /// RP:tns:FinancialInstitutionAccount.FinancialInstitutionAccount.Number
        /// </summary>
        public string TRTAMI42 = null;

        /// <summary>
        /// RP:tns:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text
        /// </summary>
        public string TRTAMI43 = null;

        /// <summary>
        /// RP:tns:OrganisationDetails.MainIncomeActivity.Description
        /// </summary>
        public string TRTAMI44 = null;

        /// <summary>
        /// RP:tns:OrganisationDetails.OrganisationIndustry2006Extended.Code
        /// </summary>
        public string TRTAMI45 = null;

        /// <summary>
        /// RP:tns:Income.Interest.EarlyPaymentCredit.Amount
        /// </summary>
        public decimal? TRTAMI46 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.RelatedPartiesTransactionsExcessAggregateValue.Indicator
        /// </summary>
        public bool? TRTAMI47 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.ProvisionsApplied.Indicator
        /// </summary>
        public bool? TRTAMI48 = null;

        /// <summary>
        /// RP:tns:Expense.Interest.Amount
        /// </summary>
        public decimal? TRTAMI49 = null;

        /// <summary>
        /// RP:tns:Expense.Royalties.Amount
        /// </summary>
        public decimal? TRTAMI50 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.TransactionsWithTaxHavenCountries.Indicator
        /// </summary>
        public bool? TRTAMI137 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.TransactionControlTaxHavenCountries.Indicator
        /// </summary>
        public bool? TRTAMI138 = null;

        /// <summary>
        /// RP:tns:Income.TrustEstateIncome.Amount
        /// </summary>
        public decimal? TRTAMI73 = null;

        /// <summary>
        /// RP:tns:IncomeTax.MultiClassTreatment.Indicator
        /// </summary>
        public bool? TRTAMI102 = null;

        /// <summary>
        /// RP:tns:IncomeTax.MultiClassTreatment.Count
        /// </summary>
        public decimal? TRTAMI103 = null;

        /// <summary>
        /// RP:tns:IncomeTax.MultiClassTransfer.Indicator
        /// </summary>
        public bool? TRTAMI104 = null;

        /// <summary>
        /// RP:tns:Elections.ManagedInvestmentTrusts.Indicator
        /// </summary>
        public bool? TRTAMI32 = null;

        /// <summary>
        /// RP:tns:IncomeTax.AttributionManagedInvestmentTrustStapledStructure.Indicator
        /// </summary>
        public bool? TRTAMI112 = null;

        /// <summary>
        /// RP:tns:Assets.PropertyPlantAndEquipment.DepreciatingAssets.FirstDeductedSelfAssessedEffectiveLife.Indicator
        /// </summary>
        public bool? TRTAMI63 = null;

        /// <summary>
        /// RP:tns:Assets.PropertyPlantAndEquipment.DepreciatingAssets.EffectiveLifeRecalculation.Indicator
        /// </summary>
        public bool? TRTAMI64 = null;

        /// <summary>
        /// RP:tns:Expense.DepreciationAllowableDeduction.Amount
        /// </summary>
        public decimal? TRTAMI118 = null;

        /// <summary>
        /// RP:tns:Expense.CapitalExpenditureSpecifiedAllowableDeduction.Amount
        /// </summary>
        public decimal? TRTAMI71 = null;

        /// <summary>
        /// RP:tns:Expense.CapitalWorksDeduction.Amount
        /// </summary>
        public decimal? TRTAMI140 = null;

        /// <summary>
        /// RP:tns:Expense.DividendInterestRoyalty.Amount
        /// </summary>
        public decimal? TRTAMI121 = null;

        /// <summary>
        /// RP:tns:Income.TrustDistributions.Amount
        /// </summary>
        public decimal? TRTAMI108 = null;

        /// <summary>
        /// RP:tns:Expense.ReturnsPaidDeduction.Amount
        /// </summary>
        public decimal? TRTAMI111 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.EligibleInvestmentBusiness.Code
        /// </summary>
        public string TRTAMI113 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.CreditsEligibleTotal.Amount
        /// </summary>
        public decimal? TRTAMI114 = null;

        /// <summary>
        /// RP:tns:IncomeTax.RentalSafeHarbour.Indicator
        /// </summary>
        public bool? TRTAMI116 = null;

        /// <summary>
        /// RP:tns:IncomeTax.EligibleInvestmentBusinessSafeHarbour.Indicator
        /// </summary>
        public bool? TRTAMI115 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.NonEligibleInvestmentBusinessPercentage.Code
        /// </summary>
        public string TRTAMI141 = null;

        /// <summary>
        /// RP:tns:IncomeTax.AttributionManagedInvestmentTrustRelatedEntitiesPayment.Indicator
        /// </summary>
        public bool? TRTAMI117 = null;

        /// <summary>
        /// RP:tns:IncomeTax.RelatedEntitiesPaymentsReceived.Amount
        /// </summary>
        public decimal? TRTAMI142 = null;

        /// <summary>
        /// RP:tns:Report.Statement.Summary.PaymentRefundOrNil.Code
        /// </summary>
        public string TRTAMI33 = null;

        /// <summary>
        /// RP:tns:Lodgment.FinalReturn.Indicator
        /// </summary>
        public bool? TRTAMI34 = null;

        /// <summary>
        /// RP:tns:RegulatoryDisclosures.GeneralInformationAboutFinancialStatements.Text
        /// </summary>
        public string TRTAMI101 = null;

        /// <summary>
        /// RP:tns:Report.CompletionHours.Number
        /// </summary>
        public decimal? TRTAMI74 = null;

        public string RPInstantId = null;
        public bool RPInstantExists = false;
        public int RPInstantCount = 0;
        public int RPInstantOccurrenceIndex = 0;
        public int RPInstantLastOccurrenceIndex = 0;
        public string RPInstantIdentifier = null;
        public string RPInstantIdentifierScheme = null;
        public string RPInstantIdentifierTFN = null;
        public DateTime? RPInstantInstantDate = null;

        /// <summary>
        /// RPInstant:tns:Assets.CurrentTotal.Amount
        /// </summary>
        public decimal? TRTAMI57 = null;

        /// <summary>
        /// RPInstant:tns:Assets.Total.Amount
        /// </summary>
        public decimal? TRTAMI58 = null;

        /// <summary>
        /// RPInstant:tns:Liabilities.CurrentTotal.Amount
        /// </summary>
        public decimal? TRTAMI59 = null;

        /// <summary>
        /// RPInstant:tns:Liabilities.Total.Amount
        /// </summary>
        public decimal? TRTAMI60 = null;

        public string RPPOSId = null;
        public bool RPPOSExists = false;
        public int RPPOSCount = 0;
        public int RPPOSOccurrenceIndex = 0;
        public int RPPOSLastOccurrenceIndex = 0;
        public string RPPOSIdentifier = null;
        public string RPPOSIdentifierScheme = null;
        public string RPPOSIdentifierTFN = null;
        public DateTime? RPPOSStartDate = null;
        public DateTime? RPPOSEndDate = null;

        /// <summary>
        /// RPPOS:tns:AddressDetails.Line1.Text
        /// </summary>
        public string TRTAMI12 = null;

        /// <summary>
        /// RPPOS:tns:AddressDetails.Line2.Text
        /// </summary>
        public string TRTAMI13 = null;

        /// <summary>
        /// RPPOS:tns:AddressDetails.LocalityName.Text
        /// </summary>
        public string TRTAMI14 = null;

        /// <summary>
        /// RPPOS:tns:AddressDetails.StateOrTerritory.Code
        /// </summary>
        public string TRTAMI15 = null;

        /// <summary>
        /// RPPOS:tns:AddressDetails.Postcode.Text
        /// </summary>
        public string TRTAMI16 = null;

        /// <summary>
        /// RPPOS:tns:AddressDetails.Country.Code
        /// </summary>
        public string TRTAMI17 = null;

        public string RPPOSPrevId = null;
        public bool RPPOSPrevExists = false;
        public int RPPOSPrevCount = 0;
        public int RPPOSPrevOccurrenceIndex = 0;
        public int RPPOSPrevLastOccurrenceIndex = 0;
        public string RPPOSPrevIdentifier = null;
        public string RPPOSPrevIdentifierScheme = null;
        public string RPPOSPrevIdentifierTFN = null;
        public DateTime? RPPOSPrevStartDate = null;
        public DateTime? RPPOSPrevEndDate = null;

        /// <summary>
        /// RPPOSPrev:tns:AddressDetails.Line1.Text
        /// </summary>
        public string TRTAMI18 = null;

        /// <summary>
        /// RPPOSPrev:tns:AddressDetails.Line2.Text
        /// </summary>
        public string TRTAMI19 = null;

        /// <summary>
        /// RPPOSPrev:tns:AddressDetails.LocalityName.Text
        /// </summary>
        public string TRTAMI20 = null;

        /// <summary>
        /// RPPOSPrev:tns:AddressDetails.StateOrTerritory.Code
        /// </summary>
        public string TRTAMI21 = null;

        /// <summary>
        /// RPPOSPrev:tns:AddressDetails.Postcode.Text
        /// </summary>
        public string TRTAMI22 = null;

        /// <summary>
        /// RPPOSPrev:tns:AddressDetails.Country.Code
        /// </summary>
        public string TRTAMI23 = null;

        public string RPPrevId = null;
        public bool RPPrevExists = false;
        public int RPPrevCount = 0;
        public int RPPrevOccurrenceIndex = 0;
        public int RPPrevLastOccurrenceIndex = 0;
        public string RPPrevIdentifier = null;
        public string RPPrevIdentifierScheme = null;
        public string RPPrevIdentifierTFN = null;
        public DateTime? RPPrevStartDate = null;
        public DateTime? RPPrevEndDate = null;

        /// <summary>
        /// RPPrev:tns:OrganisationNameDetails.OrganisationalName.Text
        /// </summary>
        public string TRTAMI11 = null;

        public string RPTrusteeId = null;
        public bool RPTrusteeExists = false;
        public int RPTrusteeCount = 0;
        public int RPTrusteeOccurrenceIndex = 0;
        public int RPTrusteeLastOccurrenceIndex = 0;
        public string RPTrusteeIdentifier = null;
        public string RPTrusteeIdentifierScheme = null;
        public string RPTrusteeIdentifierTFN = null;
        public DateTime? RPTrusteeStartDate = null;
        public DateTime? RPTrusteeEndDate = null;

        /// <summary>
        /// RPTrustee:tns:PersonNameDetails.Title.Text
        /// </summary>
        public string TRTAMI24 = null;

        /// <summary>
        /// RPTrustee:tns:PersonNameDetails.FamilyName.Text
        /// </summary>
        public string TRTAMI25 = null;

        /// <summary>
        /// RPTrustee:tns:PersonNameDetails.GivenName.Text
        /// </summary>
        public string TRTAMI26 = null;

        /// <summary>
        /// RPTrustee:tns:PersonNameDetails.OtherGivenName.Text
        /// </summary>
        public string TRTAMI27 = null;

        /// <summary>
        /// RPTrustee:tns:OrganisationNameDetails.OrganisationalName.Text
        /// </summary>
        public string TRTAMI28 = null;

        /// <summary>
        /// RPTrustee:tns:Identifiers.AustralianBusinessNumber.Identifier
        /// </summary>
        public string TRTAMI29 = null;

        /// <summary>
        /// RPTrustee:tns:ElectronicContact.Telephone.Area.Code
        /// </summary>
        public string TRTAMI30 = null;

        /// <summary>
        /// RPTrustee:tns:ElectronicContact.Telephone.Minimal.Number
        /// </summary>
        public string TRTAMI31 = null;

        public string RPStapledEntityId = null;
        public bool RPStapledEntityExists = false;
        public int RPStapledEntityCount = 0;
        public int RPStapledEntityOccurrenceIndex = 0;
        public int RPStapledEntityLastOccurrenceIndex = 0;
        public string RPStapledEntityIdentifier = null;
        public string RPStapledEntityIdentifierScheme = null;
        public string RPStapledEntityIdentifierTFN = null;
        public DateTime? RPStapledEntityStartDate = null;
        public DateTime? RPStapledEntityEndDate = null;

        /// <summary>
        /// RPStapledEntity:tns:Identifiers.AustralianBusinessNumber.Identifier
        /// </summary>
        public List<string> TRTAMI139Collection = null;
        public List<RPSoASeqNumContext> RPSoASeqNumContextCollection = null;
        public class RPSoASeqNumContext
        {

            public string Id = null;
            public bool Exists = false;
            public int Count = 0;
            public int OccurrenceIndex = 0;
            public int LastOccurrenceIndex = 0;
            public string Identifier = null;
            public string IdentifierScheme = null;
            public string IdentifierTFN = null;
            public DateTime? StartDate = null;
            public DateTime? EndDate = null;

            public string SequenceNumberDimensionValue = null;

            /// <summary>
            /// RPSoASeqNum:tns:Identifiers.TaxFileNumber.Identifier
            /// </summary>
            public string TRTAMI75 = null;

            /// <summary>
            /// RPSoASeqNum:tns:PersonNameDetails.Title.Text
            /// </summary>
            public string TRTAMI76 = null;

            /// <summary>
            /// RPSoASeqNum:tns:PersonNameDetails.FamilyName.Text
            /// </summary>
            public string TRTAMI77 = null;

            /// <summary>
            /// RPSoASeqNum:tns:PersonNameDetails.GivenName.Text
            /// </summary>
            public string TRTAMI78 = null;

            /// <summary>
            /// RPSoASeqNum:tns:PersonNameDetails.OtherGivenName.Text
            /// </summary>
            public string TRTAMI79 = null;

            /// <summary>
            /// RPSoASeqNum:tns:PersonDemographicDetails.Birth.Date
            /// </summary>
            public DateTime? TRTAMI124 = null;

            /// <summary>
            /// RPSoASeqNum:tns:OrganisationNameDetails.OrganisationalName.Text
            /// </summary>
            public string TRTAMI80 = null;

            /// <summary>
            /// RPSoASeqNum:tns:IncomeTax.AssessmentCalculation.Code
            /// </summary>
            public string TRTAMI81 = null;

            /// <summary>
            /// RPSoASeqNum:tns:InternationalDealings.AssessableIncomeNonResidentBeneficiary.Amount
            /// </summary>
            public decimal? TRTAMI82 = null;
        }
        public List<RPSoASeqNumBUSContext> RPSoASeqNumBUSContextCollection = null;
        public class RPSoASeqNumBUSContext
        {

            public string Id = null;
            public bool Exists = false;
            public int Count = 0;
            public int OccurrenceIndex = 0;
            public int LastOccurrenceIndex = 0;
            public string Identifier = null;
            public string IdentifierScheme = null;
            public string IdentifierTFN = null;
            public DateTime? StartDate = null;
            public DateTime? EndDate = null;

            public string SequenceNumberDimensionValue = null;

            /// <summary>
            /// RPSoASeqNumBUS:tns:AddressDetails.Line1.Text
            /// </summary>
            public string TRTAMI131 = null;

            /// <summary>
            /// RPSoASeqNumBUS:tns:AddressDetails.Line2.Text
            /// </summary>
            public string TRTAMI132 = null;

            /// <summary>
            /// RPSoASeqNumBUS:tns:AddressDetails.LocalityName.Text
            /// </summary>
            public string TRTAMI133 = null;

            /// <summary>
            /// RPSoASeqNumBUS:tns:AddressDetails.PostalCode.Text
            /// </summary>
            public string TRTAMI144 = null;

            /// <summary>
            /// RPSoASeqNumBUS:tns:AddressDetails.Country.Code
            /// </summary>
            public string TRTAMI136 = null;
        }
        public List<RPSoASeqNumRESContext> RPSoASeqNumRESContextCollection = null;
        public class RPSoASeqNumRESContext
        {

            public string Id = null;
            public bool Exists = false;
            public int Count = 0;
            public int OccurrenceIndex = 0;
            public int LastOccurrenceIndex = 0;
            public string Identifier = null;
            public string IdentifierScheme = null;
            public string IdentifierTFN = null;
            public DateTime? StartDate = null;
            public DateTime? EndDate = null;

            public string SequenceNumberDimensionValue = null;

            /// <summary>
            /// RPSoASeqNumRES:tns:AddressDetails.Line1.Text
            /// </summary>
            public string TRTAMI125 = null;

            /// <summary>
            /// RPSoASeqNumRES:tns:AddressDetails.Line2.Text
            /// </summary>
            public string TRTAMI126 = null;

            /// <summary>
            /// RPSoASeqNumRES:tns:AddressDetails.LocalityName.Text
            /// </summary>
            public string TRTAMI127 = null;

            /// <summary>
            /// RPSoASeqNumRES:tns:AddressDetails.PostalCode.Text
            /// </summary>
            public string TRTAMI143 = null;

            /// <summary>
            /// RPSoASeqNumRES:tns:AddressDetails.Country.Code
            /// </summary>
            public string TRTAMI130 = null;
        }

        public string RPTrueAndCorrectId = null;
        public bool RPTrueAndCorrectExists = false;
        public int RPTrueAndCorrectCount = 0;
        public int RPTrueAndCorrectOccurrenceIndex = 0;
        public int RPTrueAndCorrectLastOccurrenceIndex = 0;
        public string RPTrueAndCorrectIdentifier = null;
        public string RPTrueAndCorrectIdentifierScheme = null;
        public string RPTrueAndCorrectIdentifierTFN = null;
        public DateTime? RPTrueAndCorrectStartDate = null;
        public DateTime? RPTrueAndCorrectEndDate = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:Identifiers.TaxFileNumber.Identifier
        /// </summary>
        public string TRTAMI93 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:PersonUnstructuredName.FullName.Text
        /// </summary>
        public string TRTAMI94 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:PersonNameDetails.Position.Text
        /// </summary>
        public string TRTAMI95 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:ElectronicContact.Telephone.Area.Code
        /// </summary>
        public string TRTAMI96 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:ElectronicContact.Telephone.Minimal.Number
        /// </summary>
        public string TRTAMI97 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:Declaration.Signature.Date
        /// </summary>
        public DateTime? TRTAMI98 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:Declaration.StatementAccepted.Indicator
        /// </summary>
        public bool? TRTAMI99 = null;

        /// <summary>
        /// RPTrueAndCorrect:tns:Declaration.SignatoryIdentifier.Text
        /// </summary>
        public string TRTAMI100 = null;

        public string INTTrueAndCorrectId = null;
        public bool INTTrueAndCorrectExists = false;
        public int INTTrueAndCorrectCount = 0;
        public int INTTrueAndCorrectOccurrenceIndex = 0;
        public int INTTrueAndCorrectLastOccurrenceIndex = 0;
        public string INTTrueAndCorrectIdentifier = null;
        public string INTTrueAndCorrectIdentifierScheme = null;
        public string INTTrueAndCorrectIdentifierABN = null;
        public DateTime? INTTrueAndCorrectStartDate = null;
        public DateTime? INTTrueAndCorrectEndDate = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:Identifiers.AustralianBusinessNumber.Identifier
        /// </summary>
        public string TRTAMI92 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:PersonUnstructuredName.FullName.Text
        /// </summary>
        public string TRTAMI83 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:PersonNameDetails.Position.Text
        /// </summary>
        public string TRTAMI84 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:ElectronicContact.Telephone.Area.Code
        /// </summary>
        public string TRTAMI85 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:ElectronicContact.Telephone.Minimal.Number
        /// </summary>
        public string TRTAMI86 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:Declaration.Signature.Date
        /// </summary>
        public DateTime? TRTAMI87 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:Declaration.StatementAccepted.Indicator
        /// </summary>
        public bool? TRTAMI88 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:Declaration.SignatoryIdentifier.Text
        /// </summary>
        public string TRTAMI89 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:Identifiers.TaxAgentClientReference.Text
        /// </summary>
        public string TRTAMI90 = null;

        /// <summary>
        /// INTTrueAndCorrect:tns:Identifiers.TaxAgentNumber.Identifier
        /// </summary>
        public string TRTAMI91 = null;

    }
}
